#include <stdlib.h>
#include <sys/wait.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

int p[2];

// On simule la commande "cat toto | wc" avec deux processus et un pipe.

void pere ()
{
	// greffer stdout sur l'entrée du pipe
	dup2(p[1],1);
	close(p[0]);
	close(p[1]);

	// exec cat toto
	execlp("cat","cat","toto",NULL);
	printf("cat failed\n");	// never happens
}

void fils ()
{
	// faire en sort que stdin lise dans le pipe
	dup2(p[0],0);
	close(p[0]);
	close(p[1]);

	// exec wc
	execlp("wc","wc",NULL);
	printf("wc failed\n");	// never happens
}

int main()
{
	pipe(p);
	if (fork()) pere(); else fils();
}

